package samples.files;

/**
 * Utility function to display progress in a human-readable way:
 */
public class ProgressFormatter {
	public static String stringFromRate(long bps) {
		int i;
		char prefixes[] = { ' ', 'K', 'M', 'G', 'T', 'P' };
		for (i = 1; (bps >= 1000000) && (i < 5); i++) {
			bps /= 1000;
		}
		return "" + bps / 1000 + "." + bps % 1000 * 10 / 1000 + " "
				+ prefixes[i] + "b/s";
	}

	public static String stringFromSizeFraction(long numerator, long denominator) {
		int i;
		String unit[] = { "B", "KB", "MB", "GB", "TB", "PB" };
		for (i = 0; (denominator >= 10000) && (i < 5); i++) {
			numerator >>= 10;
			denominator >>= 10;
		}
		return numerator + "/" + denominator + " " + unit[i];
	}

	public static String stringPercentFromSizeFraction(long numerator,
			long denominator) {
		String percentString = "0.0";
		try {
			double fraction = (double) numerator / (double) denominator;
			percentString = Double.toString(fraction * 100.0);
			percentString = percentString.substring(0, percentString.indexOf(".") + 2);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return percentString + "%";
	}
}
