package samples.files;


import com.asperasoft.faspmanager.Environment;
import com.asperasoft.faspmanager.FaspManager;
import com.asperasoft.faspmanager.RemoteLocation;
import com.asperasoft.faspmanager.TransferOrder;
import com.asperasoft.faspmanager.StreamOrder;
import com.asperasoft.faspmanager.XferParams;
import com.asperasoft.faspmanager.SerializedStreamException;

import java.io.FileInputStream;
import java.io.InputStream;
import java.io.File;

public class SimpleInputStreamUpload {

    // Set these prior to performing the transfer.
    private static final String HOST = "demo.asperasoft.com";
    private static final String USER = "asperaweb";
    private static final String PASS = "demoaspera";

    public static void main(String[] args) throws Exception {
        if (HOST.length() == 0 || USER.length() == 0 || PASS.length() == 0) {
            throw new Exception("You must specify destination host, user, and password prior to performing the transfer. " +
                    "Hint: Open SimpleInputStreamUpload.java and set the appropriate constants.");
        }

        // Specify the path to ascp4.
        Environment.setFasp2ScpPath("/Library/Aspera/bin/ascp4");

        FaspManager manager = FaspManager.getSingleton();

        FaspManagerListener faspManagerListener = new FaspManagerListener(true);
        manager.addListener(faspManagerListener);

        RemoteLocation remoteDestination = new RemoteLocation(HOST, USER, PASS);
        TransferOrder order = new StreamOrder(remoteDestination, new XferParams());

        String transferId = manager.startTransfer(order);

        // Just waiting for a session to be ready
        while (!faspManagerListener.isSessionReady()) {
            Thread.sleep(100);
        }

        InputStream stream = new FileInputStream(new File("10MB.1"));
        try {
            manager.addSource(transferId, stream, "/Upload/10MB.1");
        }
        catch (SerializedStreamException ex) {

        }
        manager.lockPersistentSession(transferId);

        while (!faspManagerListener.isSessionStopped()) {
            Thread.sleep(100);
        }

        manager.destroy();
    }
}
